3 paths=(/home/pub/video/anime $HOME/dc/autodl/cur)
8 sexpr="`cat "$d/.autodl/sexpr"`"
10 if [ -r "$d/.autodl/badlist" ]; then
11 read curep <"$d/.autodl/badlist"
12 echo "downloading bad files, curep $curep"
14 elif [ -r "$d/.autodl/curep" ]; then
15 curep="`cat "$d/.autodl/curep"`"
16 echo "downloading series, curep $curep"
19 echo "no available episode of $tag" >&2
20 echo "$tag" >>"$HOME/dc/autodl/faulty"
24 if [ -r "$d/.autodl/badsizes" ]; then
25 badsizesl="$(sed -n "s/^$curep \(.*\)$/\1/p" "$d/.autodl/badsizes")"
27 if [ -n "$badsizesl" ]; then
28 read -a badsizes <<<"$badsizesl"
30 echo "found bad size list: ${badsizes[@]}"
33 fsexpr="`printf "$sexpr" "$curep"`"
34 if [ "${#badsizes[@]}" -gt 0 ]; then
35 for badsize in "${badsizes[@]}"; do
36 fsexpr="$fsexpr & ! S=$badsize"
39 infofile="$d/.autodl/rtinfo"
40 args=(-e "$fsexpr" -t "$tag $curep" -I "$infofile")
41 if [ -r "$d/.autodl/uarg" ]; then
42 uarg="`cat "$d/.autodl/uarg"`"
43 elif [ -e "$d/.autodl/autouarg" ]; then
44 uarg="rename:$tag - %02i.avi:move:../autodl/cur/$tag"
46 if [ -n "$uarg" ]; then
47 fuarg="`printf "$uarg" "$curep"`"
48 args=("${args[@]}" -a "$fuarg")
50 outfile="`mktemp /tmp/autodlXXXXXX`"
51 echo "trying to download -- autodl ${args[@]}"
53 autodl "${args[@]}" >"$outfile" 2>&1 &
55 trap "intr=y; kill -INT $pid" USR1 INT
58 if [ "$intr" = y ]; then
59 echo "$tag interrupted"
61 if [ "$stat" -ne 0 ]; then
62 echo "Failure for $tag" >>"$HOME/dc/autodl/errorlog"
63 tail -n 20 "$outfile" >>"$HOME/dc/autodl/errorlog"
65 echo "episode $curep of $tag done"
68 echo -en "${tag}\n${curep}\n" >>"$HOME/dc/autodl/baddone"
69 egrep -v "^$curep( |\$)" "$d/.autodl/badlist" >"$d/.autodl/newbadlist"
70 mv -f "$d/.autodl/newbadlist" "$d/.autodl/badlist"
71 if [ `wc -l <"$d/.autodl/badlist"` -eq 0 ]; then
72 rm "$d/.autodl/badlist"
73 if [ -r "$d/.autodl/curep" ]; then
74 if [ -r "$d/.autodl/maxep" ] && [ "`cat "$d/.autodl/curep"`" -gt "`cat "$d/.autodl/maxep"`" ]; then
75 touch "$d/.autodl/disabled"
78 touch "$d/.autodl/disabled"
80 echo "$tag has no more bad episodes"
81 echo "$tag" >>"$HOME/dc/autodl/badmaxed"
85 echo -en "${tag}\n${curep}\n" >>"$HOME/dc/autodl/done"
87 echo "$curep" >"$d/.autodl/curep"
88 if [ -r "$d/.autodl/maxep" ]; then
89 if [ "$curep" -gt "`cat "$d/.autodl/maxep"`" ]; then
90 touch "$d/.autodl/disabled"
91 echo "$tag has reached max"
92 echo "$tag" >>"$HOME/dc/autodl/maxed"
100 rm -f "$HOME/dc/autodl/run/$tag"
103 for dir in $HOME/dc/autodl{,/cur,/run}; do
104 if [ -e "$dir" ]; then
105 if [ ! -d "$dir" ]; then
106 echo "$dir is not a directory, please remedy and restart" >&2
110 mkdir "$dir" || exit 1
114 while [ $# -gt 0 ]; do
119 pid="$(cat "$HOME/dc/autodl/run/master")"
120 if [ -z "$pid" ]; then
121 echo "autodlctl: could not read a PID from $HOME/dc/autodl/run/master" >&2
128 echo "autodlctl: unrecognized option: \"$arg\"" >&2
136 trap "done=y" INT QUIT TERM
137 echo $$ >"$HOME/dc/autodl/run/master"
138 while [ "$done" != y ]; do
139 for pidfile in $HOME/dc/autodl/run/*; do
140 if [ "$pidfile" = "$HOME/dc/autodl/run/*" ]; then break; fi
141 pid="`cat "$pidfile"`"
142 if [ -d /proc/1 -a ! -d "/proc/$pid" ]; then
143 echo "removing stale pidfile $pidfile"
147 for p in "${paths[@]}"; do
149 if [ -d "$d/.autodl" -a ! -e "$d/.autodl/disabled" ]; then
150 if [ -r "$d/.autodl/tag" ]; then
151 tag="`cat "$d/.autodl/tag"`"
153 tag="`basename "$d"`"
155 if [ -e "$d/.autodl/disable" ]; then
156 echo "disabling $tag per user request"
157 touch "$d/.autodl/disabled"
158 rm -f "$d/.autodl/disable"
159 if [ -r "$HOME/dc/autodl/run/$tag" ]; then
160 pid="`cat "$HOME/dc/autodl/run/$tag"`"
161 echo "sending SIGUSR1 to $pid"
164 echo "could not find pid for $tag"
166 elif [ ! -r "$d/.autodl/sexpr" ]; then
167 touch "$d/.autodl/disabled"
168 echo "$tag lacks sexpr" >&2
169 echo "$tag" >>"$HOME/dc/autodl/faulty"
171 if [ ! -e "$HOME/dc/autodl/run/$tag" ]; then
172 if [ $((`date +%s` - $lastget)) -gt 20 ]; then
173 getnext "$d" "$tag" &
176 echo "$pid" >"$HOME/dc/autodl/run/$tag"
186 for pidfile in $HOME/dc/autodl/run/*; do
187 if [ "$pidfile" = "$HOME/dc/autodl/run/*" ]; then break; fi
188 if [ "$(basename "$pidfile")" = master ]; then continue; fi
189 pid="`cat "$pidfile"`"
190 echo "sending SIGUSR1 to $pid for `basename "$pidfile"`"
194 rm -f "$HOME/dc/autodl/run/master"